%include rice wavelet toolbox (for comparison purposes)
path(path,'rwt');

%compile code
mex levelSet2DTIMulti.c

% read image
load StLouisTrue
n = size(f,1);
f = f-mean(f(:));
A = max(abs(f(:)));
gamma = [-20 70];
K = length(gamma);

S = zeros(size(f));
for k = 1:K
  S = S + (f >= gamma(k))/K;
end

%noise_var = 64^2/12;
noise_var = 3000;

y = f + (rand(size(f))-0.5)*sqrt(noise_var*12);
R_S = calcRisk(f,S,gamma,A);


Sy = zeros(size(f));
for k = 1:K
  Sy = Sy + (y >= gamma(k))/K;
end

R_Sy = calcRisk(f,Sy,gamma,A);

if 0 % find ideal penalty weight
  penWeightVec = linspace(0,.1,100);
  RVec = zeros(100,1);
  for k = 1:length(penWeightVec)
    S_hat = levelSet2DTIMulti(y,gamma,1/n/n,penWeightVec(k)*A);
    RVec(k) = calcRisk(f,S_hat,gamma,A);
    fprintf('k = %d, R = %f\n',k,RVec(k));
  end
  [junk,mink] = min(RVec);
  penWeight = penWeightVec(mink)
else
  penWeight = 0.01;
end

S_hat = levelSet2DTIMulti(y,gamma,1/n/n,penWeight*A);
R_Shat = calcRisk(f,S_hat,gamma,A);

h = daubcqf(2);
[wL,wH] = mrdwt(y,h);
%%% to minimize R
threshMin = 3.7*sqrt(noise_var);
f_denoise = mirdwt(wL,HardTh(wH,threshMin),h);

S_denoise = zeros(size(f));
for k = 1:K
  S_denoise = S_denoise + (f_denoise >= gamma(k))/K;
end


R_Sdenoise = calcRisk(f,S_denoise,gamma,A);

fprintf('R(S_y)-R(S) = %f\n',R_Sy-R_S);
fprintf('R(S_hat)-R(S) = %f\n',R_Shat-R_S);
fprintf('R(S_denoise)-R(S) = %f\n',R_Sdenoise-R_S);


C_l = min(f(:));
C_u = max(f(:));
figure(1);imagesc(f(6:508,6:508),[C_l,C_u]); axis image;colormap gray; axis off;title('True f');
figure(2);imagesc(S(6:508,6:508));axis image; colormap gray; axis off;title('True S');colorbar
figure(3);imagesc(y(6:508,6:508),[C_l,C_u]); axis image;colormap gray; axis off; title('y = Noisy f');
figure(4);imagesc(Sy(6:508,6:508));axis image; colormap gray; axis off;title('S_y = thresholded y');colorbar
figure(5);imagesc(S_hat(6:508,6:508));axis image; colormap gray; axis off;title('S-est = proposed estimate');colorbar
figure(6);imagesc(S_denoise(6:508,6:508));axis image; colormap gray; axis off;title('S-est_p = plug-in estimate');colorbar

