% include Rice Wavelet Toolbox (for comparison)
path(path,'rwt');

%compile code
mex levelSet2DTI.c

% read image
%f = ones(512)*128;
%f(6:508,6:508) = double(imread('StLouis.gif'));
load StLouisTrue;

n = size(f,1);
f = f-mean(f(:));
gamma = 0;
A = max(abs(f(:)))
S = (f >= gamma);

figure(1);imagesc([f A*(2*S-1)],[-A,A]);axis image;
colormap gray

%return

%noise_var = 64^2/12;
noise_var = 3000;

y = f + (rand(size(f))-0.5)*sqrt(noise_var*12);

R_S = sum((gamma-f(:)).*(2*S(:)-1)/2/A);

Sy = (y >= gamma);
R_Sy = sum((gamma-f(:)).*(2*Sy(:)-1)/2/A);


% TI Version
if 0 % find ideal penalty weight
  penWeightVec = linspace(0,.1,100);
  RVec = zeros(100,1);
  for k = 1:length(penWeightVec)
    S_hat = levelSet2DTI(y,gamma,1/n/n,penWeightVec(k)*A);
    RVec(k) = sum((gamma-f(:)).*(2*S_hat(:)-1)/2/A);
    fprintf('k = %d, R = %f\n',k,RVec(k));
  end
  [junk,mink] = min(RVec);
  penWeight = penWeightVec(mink)
else
  penWeight = 0.019;
end

% levelSetEst = levelSet2DTI(data,gamma,delta,penWeight)% levelSetEst = levelSet2DTI(data,gamma,delta,penWeight)
S_hat = levelSet2DTI(y,gamma,1/n/n,penWeight*A);

R_Shat = sum((gamma-f(:)).*(2*S_hat(:)-1)/2/A);

h = daubcqf(2);
[wL,wH] = mrdwt(y,h);

%%% to minimize R
threshMin = 3.7*sqrt(noise_var);
f_denoise = mirdwt(wL,HardTh(wH,threshMin),h);
S_denoise = (f_denoise >= gamma);
R_Sdenoise = sum((gamma-f(:)).*(2*S_denoise(:)-1)/2/A);

figure(1);imagesc(f(6:508,6:508),[-A,A]); axis image;colormap gray; axis off;title('True f');
figure(2);imagesc(S(6:508,6:508));axis image; colormap gray; axis off; title('True S')
figure(3);imagesc(y(6:508,6:508),[-A,A]); axis image;colormap gray; axis off; title('y = Noisy f');
figure(4);imagesc(Sy(6:508,6:508));axis image; colormap gray; axis off;title('S_y = thresholded y');
figure(5);imagesc(S_hat(6:508,6:508));axis image; colormap gray; axis off; title('S-est = proposed estimate')
figure(6);imagesc(S_denoise(6:508,6:508));axis image; colormap gray; axis off; title('S-est_p = plug-in estimate')

fprintf('R(S_y)-R(S) = %f\n',R_Sy-R_S);
fprintf('R(S_hat)-R(S) = %f\n',R_Shat-R_S);
fprintf('R(S_denoise)-R(S) = %f\n',R_Sdenoise-R_S);


